import { Component } from 'react';
import { Color } from 'ukelli-ui/core/utils';
import { FormLayoutProps } from 'ukelli-ui/core/form-generator/form-layout';
export interface LoginPanelProps {
    /** login API */
    login: (loginForm: any) => void;
    /** 是否登陆中 */
    logging?: boolean;
    /** 是否自动登陆中 */
    autoLoging?: boolean;
    /** 登陆框的背景图 */
    backgroundImage?: string;
    /** 登陆的 logo */
    logo?: () => JSX.Element;
    /** didMount 回调 */
    didMount?: () => void;
    /** 按钮的颜色，请参考 UI 库 Button 的配色方案 */
    btnColor?: Color;
    /** 按钮的渐变颜色 */
    btnGColor?: 'red' | 'green' | 'blue' | 'wine' | 'purple';
    /** 是否沾满屏幕 */
    fixed?: boolean;
    /** FormOptions, 参考 ukelli-ui 的 formOptions 配置 */
    formOptions: FormLayoutProps['formOptions'];
}
export default class LoginPanel extends Component<LoginPanelProps> {
    static defaultProps: {
        logging: boolean;
        autoLoging: boolean;
        btnColor: string;
        fixed: boolean;
        logo: () => JSX.Element;
    };
    formHelper: any;
    componentDidMount(): void;
    saveForm: (e: any) => void;
    render(): JSX.Element;
}
