var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from 'react';
import { FormLayout } from 'ukelli-ui';
import { Call } from 'basic-helper/call';
var gradientColorMapper = {
    red: 'linear-gradient(to right, #b8cbb8 0%, #b8cbb8 0%, #b465da 0%, #cf6cc9 33%, #ee609c 66%, #ee609c 100%)',
    green: 'linear-gradient(120deg, #2af598 0%, #009efd 100%)',
    blue: 'radial-gradient(circle 248px at center, #16d9e3 0%, #30c7ec 47%, #46aef7 100%)',
    wine: 'linear-gradient(120deg, #f093fb 0%, #f5576c 100%)',
    purple: 'linear-gradient(135deg, #667eea 0%, #764ba2 100%)',
};
var gradientColorFilter = function (color) { return gradientColorMapper[color] || color; };
var LoginPanel = /** @class */ (function (_super) {
    __extends(LoginPanel, _super);
    function LoginPanel() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.saveForm = function (e) {
            if (e && e.formHelper)
                _this.formHelper = e.formHelper;
        };
        return _this;
    }
    LoginPanel.prototype.componentDidMount = function () {
        Call(this.props.didMount);
    };
    LoginPanel.prototype.render = function () {
        var _this = this;
        var _a = this.props, logging = _a.logging, login = _a.login, backgroundImage = _a.backgroundImage, btnColor = _a.btnColor, autoLoging = _a.autoLoging, formOptions = _a.formOptions, logo = _a.logo, fixed = _a.fixed, btnGColor = _a.btnGColor;
        var submitable = !autoLoging && !logging;
        var btnTxt;
        switch (true) {
            case autoLoging:
                btnTxt = '自动登陆中...';
                break;
            case logging:
                btnTxt = '登陆中...';
                break;
            default:
                btnTxt = '登陆';
                break;
        }
        return (React.createElement("div", { className: "login-panel fixbg " + (fixed ? 'fixed' : ''), style: {
                backgroundImage: backgroundImage
            } },
            React.createElement("div", { className: "login-layout" },
                logo && logo(),
                React.createElement(FormLayout
                // className="login"
                , { 
                    // className="login"
                    formBtns: [
                        {
                            style: btnGColor ? {
                                backgroundImage: gradientColorFilter(btnGColor)
                            } : null,
                            type: 'submit',
                            text: btnTxt,
                            className: 'res login-btn',
                            color: btnColor,
                            action: submitable ? function () {
                                login(_this.formHelper.value);
                            } : undefined
                        }
                    ], 
                    // onSubmit={e => {
                    //   login(this.formHelper.value);
                    // }}
                    isMobile: true, formOptions: formOptions, ref: this.saveForm }))));
    };
    LoginPanel.defaultProps = {
        logging: false,
        autoLoging: false,
        btnColor: 'theme',
        fixed: true,
        logo: function () { return React.createElement("h3", { className: "title" }, "\u7BA1\u7406\u7CFB\u7EDF"); }
    };
    return LoginPanel;
}(Component));
export default LoginPanel;
