/**
 * 与 uke web server 通讯的 api 接口
 */
/**
 * 设置默认的操作者的用户名
 */
export declare function setDefaultUser(username: any): void;
/**
 * 设置 APIs 的地址
 */
export declare function setApiUrl(url: any): void;
/**
 * 设置 F-E-Deployment 模块的配置
 */
export declare function setFEDeployConfig({ username, apiUrl }: {
    username: any;
    apiUrl: any;
}): void;
/**
 * 获取资源
 */
export declare function getAssets(projId: any, user?: string): Promise<any>;
/**
 * 获取 ssh 的配置
 * @param {void}
 * @return {data}
 */
export declare function getSShConfig(): Promise<import("uke-request").ResData>;
/**
 * 新增 ssh config
 * @param {void}
 * @return {data}
 */
export declare function addSShConfig(data: any): Promise<import("uke-request").ResData>;
/**
 * 更新 ssh config
 * @param {void}
 * @return {data}
 */
export declare function updateSShConfig(data: any): Promise<import("uke-request").ResData>;
/**
 * 删除 ssh config
 * @param {void}
 * @return {data}
 */
export declare function delSShConfig(data: any): Promise<import("uke-request").ResData>;
/**
 * 删除资源
 */
export declare function delAsset({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 获取项目列表
 */
export declare function getProjects(options: any): Promise<import("uke-request").ResData>;
/**
 * 创建项目
 */
export declare function createProject({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 更新项目
 */
export declare function updatePropject({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 删除项目
 */
export declare function delPropject({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 发布
 */
export declare function release({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 回滚
 */
export declare function rollback({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 申请加入协作
 */
export declare function applyToJoinInProject({ projId, username }: {
    projId: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 申请加入协作
 */
export declare function approveToJoinInProject({ username, ...other }: {
    [x: string]: any;
    username?: string | undefined;
}): Promise<import("uke-request").ResData>;
/**
 * 上传资源文件
 */
export declare function uploadFile(assetData: any): Promise<null>;
/**
 * 获取审计日志
 */
export declare function getAudit(projId: any): Promise<import("uke-request").ResData>;
/**
 * 获取审计日志
 */
export declare function getSSHHost(): Promise<import("uke-request").ResData>;
/**
 * 下载链接
 */
export declare function downloadAsset(assetId: any): string;
