/**
 * 与 uke web server 通讯的 api 接口
 */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { RequestClass, urlParamsToQuery } from 'uke-request';
var $R = new RequestClass();
var apiUrl = '';
var defaultUsername = '';
var APIs = {
    project: '/project',
    asset: '/assets',
    upload: '/upload',
    release: '/release',
    download: '/download-asset',
    audit: '/audit',
    rollback: '/rollback',
    joinIn: '/join',
    approveIn: '/approve',
    getHostList: '/ssh-host',
    sshConfig: '/ssh-config',
};
/**
 * 处理 fetch 回调
 */
function parseToJson(fetchRes) {
    return __awaiter(this, void 0, void 0, function () {
        var res, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    res = null;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, fetchRes.json()];
                case 2:
                    res = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    console.log(e_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/, res];
            }
        });
    });
}
/**
 * 设置默认的操作者的用户名
 */
export function setDefaultUser(username) {
    defaultUsername = username;
}
/**
 * 设置 APIs 的地址
 */
export function setApiUrl(url) {
    apiUrl = url;
    $R.setConfig({
        baseUrl: apiUrl
    });
}
/**
 * 设置 F-E-Deployment 模块的配置
 */
export function setFEDeployConfig(_a) {
    var username = _a.username, apiUrl = _a.apiUrl;
    setDefaultUser(username);
    setApiUrl(apiUrl);
}
/**
 * 获取资源
 */
export function getAssets(projId, user) {
    if (user === void 0) { user = defaultUsername; }
    return __awaiter(this, void 0, void 0, function () {
        var getConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getConfig = {
                        // url: APIs.asset,
                        params: {
                            user: user,
                            projId: projId
                        }
                    };
                    return [4 /*yield*/, $R.get(APIs.asset, getConfig)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 获取 ssh 的配置
 * @param {void}
 * @return {data}
 */
export function getSShConfig() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $R.get(APIs.sshConfig)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 新增 ssh config
 * @param {void}
 * @return {data}
 */
export function addSShConfig(data) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $R.post(APIs.sshConfig, data)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 更新 ssh config
 * @param {void}
 * @return {data}
 */
export function updateSShConfig(data) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $R.put(APIs.sshConfig, data)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 删除 ssh config
 * @param {void}
 * @return {data}
 */
export function delSShConfig(data) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, $R.del(APIs.sshConfig, data)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 删除资源
 */
export function delAsset(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign(__assign({}, other), { username: username });
                    return [4 /*yield*/, $R.del(APIs.asset, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 获取项目列表
 */
export function getProjects(options) {
    return __awaiter(this, void 0, void 0, function () {
        var projId, range, _a, user, getConfig;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    projId = options.projId, range = options.range, _a = options.user, user = _a === void 0 ? defaultUsername : _a;
                    getConfig = {
                        url: APIs.project,
                        params: {
                            user: user,
                            projId: projId,
                            range: range
                        },
                    };
                    return [4 /*yield*/, $R.get(getConfig)];
                case 1: return [2 /*return*/, _b.sent()];
            }
        });
    });
}
/**
 * 创建项目
 */
export function createProject(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign(__assign({}, other), { username: username });
                    return [4 /*yield*/, $R.post(APIs.project, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 更新项目
 */
export function updatePropject(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign(__assign({}, other), { username: username });
                    return [4 /*yield*/, $R.put(APIs.project, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 删除项目
 */
export function delPropject(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0: return [4 /*yield*/, $R.del(APIs.project, __assign(__assign({}, other), { username: username }))];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 发布
 */
export function release(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign(__assign({}, other), { username: username });
                    return [4 /*yield*/, $R.post(APIs.release, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 回滚
 */
export function rollback(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign(__assign({}, other), { username: username });
                    return [4 /*yield*/, $R.post(APIs.rollback, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 申请加入协作
 */
export function applyToJoinInProject(_a) {
    var projId = _a.projId, _b = _a.username, username = _b === void 0 ? defaultUsername : _b;
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = { username: username, projId: projId };
                    return [4 /*yield*/, $R.post(APIs.joinIn, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 申请加入协作
 */
export function approveToJoinInProject(_a) {
    var _b = _a.username, username = _b === void 0 ? defaultUsername : _b, other = __rest(_a, ["username"]);
    return __awaiter(this, void 0, void 0, function () {
        var postData;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    postData = __assign({ username: username }, other);
                    return [4 /*yield*/, $R.post(APIs.approveIn, postData)];
                case 1: return [2 /*return*/, _c.sent()];
            }
        });
    });
}
/**
 * 上传资源文件
 */
export function uploadFile(assetData) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = parseToJson;
                    return [4 /*yield*/, $R.upload(APIs.upload, assetData)];
                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
            }
        });
    });
}
/**
 * 获取审计日志
 */
export function getAudit(projId) {
    return __awaiter(this, void 0, void 0, function () {
        var getConfig;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    getConfig = {
                        url: APIs.audit,
                        params: {
                            projId: projId
                        }
                    };
                    return [4 /*yield*/, $R.get(getConfig)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 获取审计日志
 */
export function getSSHHost() {
    return __awaiter(this, void 0, void 0, function () {
        var url;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    url = APIs.getHostList;
                    return [4 /*yield*/, $R.get(url)];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
/**
 * 下载链接
 */
// export async function downloadAsset(assetId) {
//   let config = {
//     url: APIs.download,
//     params: {
//       assetId
//     },
//     toBase64: false,
//   };
//   return await fetch(apiUrl + urlParamsToQuery(config));
// }
export function downloadAsset(assetId) {
    var config = {
        url: APIs.download,
        params: {
            assetId: assetId
        },
        toBase64: false,
    };
    return apiUrl + urlParamsToQuery(config);
    // return await fetch(apiUrl + urlParamsToQuery(config));
}
