var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React from 'react';
import PropTypes from 'prop-types';
import { Table, ShowModal, CloseGlobalModal, Loading } from 'ukelli-ui';
import { getAssets, getProjects, downloadAsset, delAsset } from './apis';
import ReleaseComfirm from './release-comfirm';
import { versionFilter } from './filter';
import ActionAgent from "../action-agent";
var prevRecords = [];
var AssetsManager = /** @class */ (function (_super) {
    __extends(AssetsManager, _super);
    function AssetsManager(props) {
        var _this = _super.call(this, props) || this;
        _this.columns = [
            {
                key: 'version',
                title: '版本',
                filter: function (str) {
                    return versionFilter(str);
                }
            },
            {
                key: 'desc',
                title: '更新日志'
            },
            {
                key: 'createdDate',
                title: '上传日期',
                datetime: true
            },
            {
                key: 'rollbackMark',
                title: '回滚原因',
                filter: function (str) {
                    return str || '-';
                }
            },
            {
                key: 'action',
                title: '操作',
                filter: function (str, item, keyMap, idx) {
                    var _a = _this.props, notify = _a.notify, username = _a.username, releasable = _a.releasable;
                    if (!releasable)
                        return '-';
                    var id = item.id, belongto = item.belongto, isRollback = item.isRollback, isReleased = item.isReleased;
                    var currProject = _this.state.currProject;
                    var releaseRef = currProject.releaseRef;
                    var isCurrReleased = isReleased && releaseRef == id;
                    var canRollback = isReleased && !isCurrReleased;
                    var releasText = '发布';
                    var options = {
                        releasText: releasText, canRollback: canRollback, item: item,
                    };
                    switch (true) {
                        case isCurrReleased:
                            releasText = '已发布';
                            break;
                        case canRollback:
                            releasText = '回滚';
                            break;
                        case isRollback:
                            releasText = '已回滚';
                            break;
                    }
                    return (React.createElement(React.Fragment, null,
                        React.createElement("button", { className: "btn theme flat", type: "submit", disabled: isRollback, onClick: function () {
                                _this.comfirmRelease(options);
                            } }, releasText),
                        React.createElement("button", { className: "red btn ml10", type: "submit", onClick: function () {
                                var ModalId = ShowModal({
                                    title: '删除',
                                    type: 'confirm',
                                    confirmText: (React.createElement("div", { className: "text-center" },
                                        React.createElement("h3", null,
                                            "\u786E\u5B9A\u5220\u9664 ",
                                            versionFilter(item.version),
                                            " ?"),
                                        React.createElement("h5", null, "\u7CFB\u7EDF\u5C06\u4F1A\u628A\u8D44\u6E90\u6587\u4EF6\u4E5F\u5220\u9664\uFF0C\u4E0D\u53EF\u6062\u590D."))),
                                    width: 340,
                                    onConfirm: function (isDel) { return __awaiter(_this, void 0, void 0, function () {
                                        var delRes, isSuccess;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    if (!isDel)
                                                        return [2 /*return*/];
                                                    return [4 /*yield*/, delAsset({ assetId: id, projId: belongto })];
                                                case 1:
                                                    delRes = _a.sent();
                                                    isSuccess = !delRes.err;
                                                    if (isSuccess) {
                                                        CloseGlobalModal(ModalId);
                                                        this.onReleased();
                                                    }
                                                    notify('删除', isSuccess);
                                                    return [2 /*return*/];
                                            }
                                        });
                                    }); }
                                });
                            } }, "\u5220\u9664"),
                        React.createElement("a", { className: "link-btn ml10", href: downloadAsset(id) }, "\u4E0B\u8F7D")));
                }
            }
        ];
        _this.comfirmRelease = function (options) {
            var _a = _this.props, notify = _a.notify, username = _a.username, getProject = _a.getProject;
            var releasText = options.releasText, canRollback = options.canRollback, item = options.item;
            var project = getProject();
            var ModalId = ShowModal({
                title: releasText,
                showFuncBtn: false,
                width: 560,
                children: (React.createElement(ReleaseComfirm, __assign({ canRollback: canRollback, onCancel: function (e) { return CloseGlobalModal(ModalId); }, onReleased: function (isSuccess) {
                        CloseGlobalModal(ModalId);
                        // this.props.notify(releasText, isSuccess);
                        isSuccess && _this.queryData();
                    } }, _this.props, { asset: item, project: project }))),
            });
        };
        _this.onReleased = function () {
            _this.setState({
                querying: true
            });
            _this.queryData();
        };
        _this.state = {
            records: prevRecords,
            querying: true,
            currProject: {}
        };
        return _this;
    }
    AssetsManager.prototype.componentDidMount = function () {
        this.queryData();
    };
    AssetsManager.prototype.queryData = function () {
        return __awaiter(this, void 0, void 0, function () {
            var projId, assetRecord, projectData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        projId = this.props.projId;
                        this.setState({
                            querying: true,
                        });
                        return [4 /*yield*/, getAssets(projId)];
                    case 1:
                        assetRecord = (_a.sent()).data || [];
                        return [4 /*yield*/, getProjects({ projId: projId })];
                    case 2:
                        projectData = (_a.sent()).data || [];
                        prevRecords = assetRecord;
                        this.setState({
                            records: assetRecord,
                            currProject: projectData,
                            querying: false
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    AssetsManager.prototype.objToArr = function (obj) {
        var res = [];
        Object.keys(obj).forEach(function (id) { return res.push(obj[id]); });
        res = res.sort(function (prevItem, nextItem) { return nextItem.version - prevItem.version; });
        return res;
    };
    AssetsManager.prototype.render = function () {
        var _a = this.state, records = _a.records, querying = _a.querying;
        return (React.createElement(Loading, { loading: querying, inrow: true },
            React.createElement(Table, { columns: this.columns, records: records, needCount: false })));
    };
    AssetsManager.propTypes = {
        notify: PropTypes.func.isRequired,
        getProject: PropTypes.func.isRequired,
        username: PropTypes.string,
        releasable: PropTypes.bool
    };
    AssetsManager.defaultProps = {
        releasable: false
    };
    return AssetsManager;
}(ActionAgent));
export default AssetsManager;
