/**
 * 发布日志
 */
/// <reference types="react" />
import PropTypes from 'prop-types';
import ActionAgent from "../action-agent";
declare class AuditLog extends ActionAgent {
    static propTypes: {
        projId: PropTypes.Requireable<string>;
    };
    columns: ({
        key: string;
        title: string;
        datetime?: undefined;
        namesMapper?: undefined;
    } | {
        key: string;
        title: string;
        datetime: boolean;
        namesMapper?: undefined;
    } | {
        key: string;
        title: string;
        namesMapper: {
            rollback: string;
            release: string;
            createProj: string;
            systemDeleteAsset: string;
            deleteAsset: string;
            createAsset: string;
        };
        datetime?: undefined;
    })[];
    state: {
        loading: boolean;
        records: never[];
    };
    componentDidMount(): void;
    queryData(): Promise<void>;
    render(): JSX.Element;
}
export default AuditLog;
