/**
 * 发布日志
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import React from 'react';
import PropTypes from 'prop-types';
import { Table, Loading } from 'ukelli-ui';
import ActionAgent from "../action-agent";
import { getAudit } from './apis';
var AuditLog = /** @class */ (function (_super) {
    __extends(AuditLog, _super);
    function AuditLog() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.columns = [
            {
                key: 'operator',
                title: '操作者'
            },
            {
                key: 'date',
                title: '操作时间',
                datetime: true
            },
            {
                key: 'version',
                title: '版本'
            },
            {
                key: 'type',
                title: '发布类型',
                namesMapper: {
                    rollback: '回滚',
                    release: '资源发布',
                    createProj: '创建项目',
                    systemDeleteAsset: '系统自动清理',
                    deleteAsset: '删除项目',
                    createAsset: '上传资源'
                }
            },
            {
                key: 'note',
                title: '发布内容'
            }
        ];
        _this.state = {
            loading: true,
            records: []
        };
        return _this;
    }
    AuditLog.prototype.componentDidMount = function () {
        this.queryData();
    };
    AuditLog.prototype.queryData = function () {
        return __awaiter(this, void 0, void 0, function () {
            var auditRes;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.reqAgent(getAudit, {
                            actingRef: 'loading',
                            after: function (_a) {
                                var data = _a.data;
                                return ({
                                    records: data
                                });
                            }
                        })(this.props.projId)];
                    case 1:
                        auditRes = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    AuditLog.prototype.render = function () {
        var _a = this.state, records = _a.records, loading = _a.loading;
        return (React.createElement("div", { className: "p10" },
            React.createElement(Loading, { loading: loading, inrow: true },
                React.createElement(Table, { columns: this.columns, records: records, needCount: false }))));
    };
    AuditLog.propTypes = {
        projId: PropTypes.string
    };
    return AuditLog;
}(ActionAgent));
export default AuditLog;
