var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { getSSHHost, getSShConfig } from './apis';
var wrapProjectFormOptions = function (project) {
    if (project === void 0) { project = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var hostRes, hostConfigRes, hostMapper, formOptions;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getSSHHost()];
                case 1:
                    hostRes = _a.sent();
                    return [4 /*yield*/, getSShConfig()];
                case 2:
                    hostConfigRes = _a.sent();
                    console.log(hostRes, hostConfigRes);
                    hostMapper = hostRes.mapper || {};
                    formOptions = [
                        {
                            type: 'input',
                            required: true,
                            ref: 'projName',
                            title: '项目名称',
                            defaultValue: project.projName,
                            desc: '项目显示名称'
                        },
                        !project.projCode ? {
                            type: 'input',
                            required: true,
                            ref: 'projCode',
                            title: '项目代号',
                            desc: '确定后不可修改'
                        } : {
                            type: 'text',
                            ref: 'projCode',
                            title: '项目代号',
                            defaultValue: project.projCode,
                        },
                        {
                            type: 'input',
                            ref: 'projDesc',
                            title: '项目介绍',
                            defaultValue: project.projDesc,
                        },
                        {
                            type: 'input',
                            ref: 'host',
                            title: '项目域名',
                            defaultValue: project.host,
                        },
                        {
                            type: 'input',
                            ref: 'webhook',
                            title: 'web hook',
                            desc: '开发人员填写',
                            defaultValue: project.webhook,
                        },
                        {
                            type: 'select',
                            ref: 'scpTargetHost',
                            title: 'SCP Host',
                            position: 'top',
                            values: hostMapper,
                            desc: '请咨询 SA',
                            defaultValue: project.scpTargetHost,
                        },
                        {
                            type: 'input',
                            ref: 'scpTargetDir',
                            title: 'SSH 的部署目录',
                            desc: '请咨询 SA 对应的目录',
                            defaultValue: project.scpTargetDir,
                        },
                        {
                            type: 'input',
                            ref: 'scpSourceDir',
                            title: '资源目录',
                            desc: '请查看打包配置',
                            defaultValue: project.scpSourceDir,
                        },
                        {
                            type: 'radio',
                            ref: 'pushMode',
                            title: '发布方式',
                            values: {
                                'push-files': '推送解压后的文件(慢, 但是安全)',
                                'push-zip': '推送压缩资源到目标服务器再解压(快, 但需要目标服务器支持)',
                            },
                            defaultValue: project.pushMode || 'push-files',
                        },
                        {
                            type: 'hidden',
                            ref: 'projId',
                            defaultValue: project.id
                        },
                    ];
                    return [2 /*return*/, formOptions];
            }
        });
    });
};
export default wrapProjectFormOptions;
