var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import { Loading, Table, Notify, ShowModal, Button, ConditionGenerator, CloseGlobalModal } from 'ukelli-ui';
import { GenerteID } from 'basic-helper';
import ActionAgent from "../action-agent";
import { getProjects } from './apis';
import ProjectManager from './project-manager';
import CreateProjectHelper from './create-project';
import ApprovePanel from './approve-panel';
import Manual from './manual';
var ProjectList = /** @class */ (function (_super) {
    __extends(ProjectList, _super);
    function ProjectList(props) {
        var _this = _super.call(this, props) || this;
        _this.state = __assign(__assign({}, _this.state), { records: [], querying: true });
        _this.getProject = function (idx) {
            return _this.state.records[idx];
        };
        _this.queryData = function () { return __awaiter(_this, void 0, void 0, function () {
            var range, postData, agentOptions, resData;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        range = this.conditionRef.value.range;
                        postData = { range: range };
                        agentOptions = {
                            actingRef: 'querying',
                            after: function (res) { return ({
                                records: res.data
                            }); },
                            resFilter: function (res) { return res.data; }
                        };
                        return [4 /*yield*/, this.reqAgent(getProjects, agentOptions)(postData)];
                    case 1:
                        resData = _a.sent();
                        return [2 /*return*/, this.projRecordSearch(resData)];
                }
            });
        }); };
        _this.handleSearch = function (e) {
            _this.setState({
                searchValue: e.target.value
            });
        };
        _this.getAssetsRecord = function (idx) {
            return _this.state.records[idx];
        };
        _this.pathFilter = function (str) {
            var defaultPath = '/assets';
            var _a = str.split(defaultPath), start = _a[0], end = _a[1];
            return end ? "~" + defaultPath + end : start;
        };
        _this.notify = function (title, isSuccess, text) {
            var normalType = typeof isSuccess == 'undefined';
            Notify({
                config: {
                    id: GenerteID(),
                    type: normalType ? 'normal' : isSuccess ? 'success' : 'error',
                    title: normalType ? title : title + (isSuccess ? '成功' : '失败'),
                    text: text
                }
            });
        };
        _this.conditionOptions = [
            {
                type: 'radio',
                ref: 'range',
                defaultValue: 'me',
                title: '项目',
                values: {
                    me: '我的',
                    join: '我参与的',
                    all: '全部',
                }
            },
            {
                refu: {
                    projName: '项目名',
                    projCode: '项目编码',
                    founder: '创建者',
                },
                type: 'input-selector',
            },
        ];
        _this.columns = [
            {
                key: 'projName',
                title: '项目名',
                filter: function (str, item, _, idx) {
                    return (React.createElement("span", { className: "link-btn", onClick: function () {
                            _this.showProjectDetail(item, idx, 'edit');
                        } }, str));
                }
            },
            {
                key: 'actions',
                title: '操作',
                filter: function (_, item, __, idx) {
                    return (React.createElement("div", null,
                        React.createElement("span", { className: "link-btn mr10", onClick: function (e) { return _this.showProjectDetail(item, idx, 'asset-list'); } }, "\u8D44\u6E90\u5217\u8868"),
                        React.createElement("span", { className: "link-btn mr10", onClick: function (e) { return _this.showProjectDetail(item, idx, 'upload'); } }, "\u4E0A\u4F20\u65B0\u8D44\u6E90")));
                }
            },
            {
                key: 'projCode',
                title: '项目编码'
            },
            {
                key: 'founder',
                title: '创建人'
            },
            {
                key: 'collaborators',
                title: '协作者',
                filter: function (collaboratorsObj) {
                    var collaborators = Object.keys(collaboratorsObj);
                    var hasCollaborators = collaborators.length > 0;
                    var collaboratorsDOM = hasCollaborators ? collaborators.join(',') : '-';
                    return collaboratorsDOM;
                }
            },
            {
                key: 'collaboratorApplies',
                title: '申请协作者',
                filter: function (applicants, item) {
                    if (applicants === void 0) { applicants = []; }
                    var applicantDOM = applicants.map(function (applicant) {
                        return (React.createElement("p", { key: applicant },
                            React.createElement("span", { className: "link-btn", onClick: function (e) {
                                    var ModalId = ShowModal({
                                        title: "\u540C\u610F " + applicant + " \u52A0\u5165\u534F\u4F5C",
                                        width: 500,
                                        showFuncBtn: false,
                                        children: (React.createElement(ApprovePanel, __assign({}, _this.passProps(), { projId: item.id, applicant: applicant, onUpdated: function (e) {
                                                _this.queryData();
                                                CloseGlobalModal(ModalId);
                                            } })))
                                    });
                                } }, applicant)));
                    });
                    return applicantDOM;
                }
            },
            {
                key: 'createdDate',
                title: '创建日期',
                datetime: true
            },
        ];
        return _this;
    }
    ProjectList.prototype.componentDidMount = function () {
        this.queryData();
    };
    ProjectList.prototype.showProjectDetail = function (targetItem, idx, type) {
        var _this = this;
        if (type === void 0) { type = 'edit'; }
        var projName = targetItem.projName;
        var ModalId = ShowModal({
            title: "\u9879\u76EE " + projName + " \u7BA1\u7406",
            width: 900,
            // draggable: true,
            showFuncBtn: false,
            children: (React.createElement(ProjectManager, __assign({}, this.passProps(), { defaultTab: type, onApplied: function (e) { return CloseGlobalModal(ModalId); }, onClose: function (e) { return CloseGlobalModal(ModalId); }, getProject: function (e) { return _this.getProject(idx); } })))
        });
    };
    ProjectList.prototype.passProps = function () {
        return __assign(__assign({}, this.props), { notify: this.notify, queryProject: this.queryData });
    };
    ProjectList.prototype.create = function () {
        var _this = this;
        var ModalId = ShowModal({
            title: '创建项目',
            width: 900,
            showFuncBtn: false,
            children: (React.createElement(CreateProjectHelper, __assign({}, this.props, { notify: this.notify, close: function (e) { return CloseGlobalModal(ModalId); }, onCreatedProject: function () {
                    _this.queryData();
                } })))
        });
    };
    /**
     * 根据 input-selector 的输入来过滤结果
     */
    ProjectList.prototype.projRecordSearch = function (records) {
        if (!records)
            return [];
        var _a = this.conditionRef.value, founder = _a.founder, projCode = _a.projCode, projName = _a.projName;
        var filterArr = { founder: founder, projCode: projCode, projName: projName };
        var nextRecords = __spreadArrays(records);
        if (!!founder || !!projCode || !!projName) {
            nextRecords = nextRecords.filter(function (item) {
                var isActive = false;
                Object.keys(filterArr).forEach(function (filterName) {
                    var searchProj = filterArr[filterName];
                    if (!searchProj)
                        return;
                    isActive = item[filterName].indexOf(searchProj) != -1;
                });
                return isActive;
            });
        }
        return nextRecords;
    };
    ProjectList.prototype.render = function () {
        var _this = this;
        var _a = this.state, records = _a.records, querying = _a.querying;
        return (React.createElement("div", null,
            React.createElement(Loading, { loading: querying, inrow: true },
                React.createElement("div", { className: "project-list p10" },
                    React.createElement(ConditionGenerator, { ref: function (e) { return _this.conditionRef = e; }, conditionConfig: this.conditionOptions },
                        React.createElement(Button, { icon: "feather", className: "btn theme flat", onClick: function (e) { return _this.queryData(); }, text: "\u67E5\u8BE2" })),
                    React.createElement("div", { className: "action-group" },
                        React.createElement(Button, { text: "\u521B\u5EFA\u9879\u76EE", icon: "plus", className: "mr10", onClick: function () { return _this.create(); } }),
                        React.createElement("span", { className: "btn red mr10", onClick: function (e) { return ShowModal({
                                width: 800,
                                title: '发布系统的使用手册',
                                children: React.createElement(Manual, null)
                            }); } }, "\u67E5\u770B\u4F7F\u7528\u624B\u518C"),
                        React.createElement("span", { className: "btn green mr10", onClick: function (e) {
                                _this.props.onNavigate({
                                    type: 'PUSH',
                                    route: 'DeployManager'
                                });
                                // ShowModal({
                                //   width: 800,
                                //   title: '部署路径配置',
                                //   showFuncBtn: false,
                                //   children: <DeployConfigManager />
                                // });
                            } }, "\u90E8\u7F72\u8DEF\u5F84\u914D\u7F6E")),
                    React.createElement(Table, { columns: this.columns, records: records, needCount: false })))));
    };
    return ProjectList;
}(ActionAgent));
export default ProjectList;
