/**
 * 主要布局文件, 不需要单独修改, 以后统一修改
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import Mousetrap from 'mousetrap';
import { ToggleBasicFloatLen, IsFunc } from 'basic-helper';
import { VersionDisplayer, VersionChecker } from 'version-helper';
import { ShowModal, Tabs, Tab, DropdownMenu, Loading, setUkeLang, Icon, setLangTranslate } from './ui-refs';
import { showShortcut, ShortcutDesc } from './shortcut';
import NavMenu from './nav-menu';
// import Posts from './posts';
import { RouterHelper } from './router-multiple';
// import VersionComponent, { VersionChecker, VersionCheckerProps } from './plugins/version-com';
import { Notfound, DashBoardWrapper, DefaultStatusbar, FooterContainer, TabForNavBar, Theme } from './plugins';
import { getThemeConfig, setTheme, setLayout, setDarkMode } from './plugins/theme';
var LANG_MAPPER = {};
var CURR_LANG_MAPPER = {};
var ScaffoldLayout = /** @class */ (function (_super) {
    __extends(ScaffoldLayout, _super);
    function ScaffoldLayout(props) {
        var _this = _super.call(this, props) || this;
        _this.initThemeConfig = function () {
            // const THEME = Storage.getItem()
            var themeConfig = getThemeConfig();
            return Object.assign({}, {
                theme: _this.props.defaultTheme,
                darkMode: _this.props.defaultDarkMode,
                layout: _this.props.defaultLayout,
            }, themeConfig);
        };
        _this.geti18nUrl = function (lang) {
            var i18nMapperUrl = _this.props.i18nMapperUrl;
            if (!i18nMapperUrl)
                return null;
            return i18nMapperUrl + lang + ".json";
        };
        _this.changeLang = function (lang) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!lang)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.fetchLangMapper(lang)];
                    case 1:
                        _a.sent();
                        this.setUILang(lang);
                        this.setState({
                            lang: lang,
                        });
                        return [2 /*return*/];
                }
            });
        }); };
        _this.setUILang = function (lang) {
            /** 设置 UI 库的国际化 */
            // setLangTranslate({
            //   [lang]: LANG_MAPPER[lang]
            // });
            CURR_LANG_MAPPER = LANG_MAPPER[lang] || {};
            setLangTranslate(LANG_MAPPER);
            setUkeLang(lang);
        };
        _this.changeTheme = function (nextTheme) {
            _this.setState({
                theme: nextTheme,
            });
            setTheme(nextTheme);
        };
        _this.changeDarkMode = function (nextDarkMode) {
            _this.setState({
                darkMode: nextDarkMode,
            });
            setDarkMode(nextDarkMode);
        };
        _this.changeLayout = function (nextLayout) {
            _this.setState({
                layout: nextLayout,
            });
            setLayout(nextLayout);
        };
        _this.fetchLangMapper = function (lang) { return __awaiter(_this, void 0, void 0, function () {
            var url, mapper, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.geti18nUrl(lang);
                        if (!url)
                            return [2 /*return*/, null];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, fetch(url)];
                    case 2: return [4 /*yield*/, (_a.sent()).json()];
                    case 3:
                        mapper = _a.sent();
                        if (!LANG_MAPPER[lang])
                            LANG_MAPPER[lang] = {};
                        Object.assign(LANG_MAPPER[lang], mapper);
                        return [2 /*return*/, mapper];
                    case 4:
                        e_1 = _a.sent();
                        console.log(e_1);
                        return [2 /*return*/, {}];
                    case 5: return [2 /*return*/];
                }
            });
        }); };
        _this.$T = function (key) {
            return key === 'all' ? CURR_LANG_MAPPER : CURR_LANG_MAPPER[key] || key || '';
        };
        _this.triggerResize = function () {
            setTimeout(function () {
                var evt = window.document.createEvent('UIEvents');
                evt.initUIEvent('resize', true, false, window, 0);
                window.dispatchEvent(evt);
            }, 50);
        };
        _this.handleCloseFormShortcut = function () {
            var _a = _this.state, activeRouteIdx = _a.activeRouteIdx, routerInfo = _a.routerInfo;
            _this.closeTab(activeRouteIdx, routerInfo);
        };
        _this.toggleFloat = function () {
            var isDisplay = ToggleBasicFloatLen();
            _this.setState(function (_a) {
                var displayFloat = _a.displayFloat;
                return ({
                    displayFloat: !displayFloat
                });
            });
        };
        _this.onGetMenuCodeMapper = function (menuCodeMapper) {
            _this.setState({
                menuCodeMapper: menuCodeMapper
            });
            window.MenuCodeMapper = menuCodeMapper;
        };
        _this.toggleNavMenu = function (showNavMenu) {
            _this.setState({
                showNavMenu: showNavMenu
            });
            _this.triggerResize();
        };
        _this.loadPlugin = function (Plugin, props) {
            var P = IsFunc(Plugin) ? React.createElement(Plugin, null) : Plugin;
            P = React.cloneElement(P, props, {
                onNavigate: _this.onNavigate
            });
            return P;
        };
        _this.statusbarConfigFilter = function () {
            var _a = _this.props, _b = _a.statusbarConfig, statusbarConfig = _b === void 0 ? [] : _b, i18nConfig = _a.i18nConfig;
            return __spreadArrays(statusbarConfig, (i18nConfig ? [_this.getI18nConfig()] : []), [
                _this.getSystemInfoConfig()
            ]);
        };
        _this.getI18nConfig = function () {
            var i18nConfig = _this.props.i18nConfig;
            var lang = _this.state.lang;
            return {
                component: (React.createElement(DropdownMenu, { key: "i18nConfig", needAction: false, onChange: function (val) { return _this.changeLang(val); }, position: "right", value: lang, values: i18nConfig }, function () { return (React.createElement("div", null,
                    React.createElement(Icon, { n: "globe", classNames: ["mr5"] }))); }))
            };
        };
        _this.getSystemInfoConfig = function () {
            return {
                icon: "ellipsis-v",
                action: _this.renderSystemInfo
            };
        };
        _this.renderSystemInfo = function () {
            var _a = _this.props, Footer = _a.Footer, versionInfo = _a.versionInfo;
            var _b = _this.state, theme = _b.theme, darkMode = _b.darkMode, layout = _b.layout;
            ShowModal({
                type: 'side',
                position: 'right',
                title: '系统设置',
                children: (React.createElement(React.Fragment, null,
                    React.createElement(ShortcutDesc, null),
                    React.createElement(Theme, { onChangeDarkMode: _this.changeDarkMode, onChangeTheme: _this.changeTheme, onChangeLayout: _this.changeLayout, layout: layout, darkMode: darkMode, activeTheme: theme }),
                    React.createElement(FooterContainer, null,
                        Footer && _this.loadPlugin(Footer, {
                            $T: _this.$T,
                        }),
                        versionInfo ? (React.createElement(VersionDisplayer, { "$T": _this.$T, versionInfo: versionInfo })) : null)))
            });
        };
        // const { pageComponents, iframeMode } = props;
        // this.pageRoutes = iframeMode ? ['Posts'] : Object.keys(pageComponents);
        // EventEmitter.on('QUERY_MENU', (resMenuData) => {
        //   this.changeMenuData(resMenuData);
        // });
        _this.state = __assign(__assign(__assign({}, _this.state), _this.initThemeConfig()), { menuCodeMapper: {}, showNavMenu: true, activeMenu: '', displayFloat: true, menuData: props.menuStore || [], lang: navigator.language, ready: false });
        _this.initApp();
        return _this;
    }
    ScaffoldLayout.prototype.initApp = function () {
        return __awaiter(this, void 0, void 0, function () {
            var i18nMapper, lang;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        i18nMapper = this.props.i18nMapper;
                        lang = this.state.lang;
                        if (i18nMapper) {
                            LANG_MAPPER = __assign({}, i18nMapper);
                        }
                        return [4 /*yield*/, this.fetchLangMapper(lang)];
                    case 1:
                        _a.sent();
                        this.setUILang(lang);
                        this.setState({
                            ready: true
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    ScaffoldLayout.prototype.componentDidMount = function () {
        var _this = this;
        Mousetrap.bind(['alt alt'], function (e) {
            _this.toggleNavMenu(!_this.state.showNavMenu);
            return false;
        });
        Mousetrap.bind(['alt+k'], function (e) { return showShortcut(); });
        Mousetrap.bind(['alt+w'], function (e) { return _this.handleCloseFormShortcut(); });
        this.initRoute();
    };
    ScaffoldLayout.prototype.componentWillUnmount = function () {
        Mousetrap.unbind(['alt+k', 'alt alt', 'alt+w']);
        this.unlisten();
    };
    ScaffoldLayout.prototype.changeMenuData = function (menuData) {
        if (menuData === void 0) { menuData = []; }
        this.setState({
            menuData: menuData
        });
    };
    ScaffoldLayout.prototype.getRouteProps = function (isActive, pageName) {
        var _a = this.props, userInfo = _a.userInfo, username = _a.username, pageProps = _a.pageProps;
        return __assign(__assign({}, pageProps), { userInfo: userInfo,
            username: username,
            isActive: isActive,
            pageName: pageName, $T: this.$T, onNavigate: this.onNavigate, history: this.history });
    };
    ScaffoldLayout.prototype.render = function () {
        var _this = this;
        var _a = this.props, username = _a.username, logout = _a.logout, pageComponents = _a.pageComponents, _b = _a.pluginComponent, pluginComponent = _b === void 0 ? {} : _b, menuMappers = _a.menuMappers, versionInfo = _a.versionInfo, versionUrl = _a.versionUrl, 
        // iframeMode,
        // i18nConfig,
        // DashBoard,
        bgStyle = _a.bgStyle, tabInStatusbar = _a.tabInStatusbar, title = _a.title;
        var _c = this.state, menuCodeMapper = _c.menuCodeMapper, showNavMenu = _c.showNavMenu, menuData = _c.menuData, activeMenu = _c.activeMenu, displayFloat = _c.displayFloat, activeRouteIdx = _c.activeRouteIdx, routerInfo = _c.routerInfo, 
        // lang,
        ready = _c.ready, layout = _c.layout, theme = _c.theme, routers = _c.routers, darkMode = _c.darkMode;
        var Statusbar = pluginComponent.Statusbar, NotfoundPage = pluginComponent.NotfoundPage, _d = pluginComponent.DashBoard, DashBoard = _d === void 0 ? this.props.DashBoard : _d;
        var routersLen = routers.length;
        var hasRouter = routersLen > 0;
        var statusbarConfig = this.statusbarConfigFilter();
        return (React.createElement("div", { id: "managerApp", className: "fill main-container fixbg " + theme + " " + layout + " " + (darkMode ? 'dark' : 'light') },
            React.createElement(Loading, { loading: !ready }, ready && (React.createElement(React.Fragment, null,
                React.createElement(NavMenu, { onDidMount: this.onGetMenuCodeMapper, menuData: menuData, title: title, logout: logout, 
                    // onClickMenu={code => {
                    //   // this.pushRoute(code)
                    // }}
                    // i18nConfig={i18nConfig}
                    // lang={lang}
                    menuMappers: menuMappers, username: username, defaultFlowMode: false, changeLang: this.changeLang, show: showNavMenu, "$T": this.$T, onToggleNav: this.toggleNavMenu, activeMenu: activeMenu }),
                React.createElement("div", { className: "pages-container " + (showNavMenu ? 'show-menu' : 'hide-menu') },
                    React.createElement("div", { className: "uke-status-bar", id: "statusBar" },
                        tabInStatusbar && (React.createElement(TabForNavBar, { changeRoute: this.changeRoute, closeTab: this.closeTab, closeAll: this.closeAll, "$T": this.$T, menuCodeMapper: menuCodeMapper, hasRouter: hasRouter, routerInfo: routerInfo, routers: routers, activeRouteIdx: activeRouteIdx, routersLen: routersLen, defaultTitle: function (e) { return _this.$T('仪表盘'); } })),
                        React.createElement("span", { className: "flex" }),
                        Statusbar && this.loadPlugin(Statusbar, {
                            onLogout: logout,
                            showShortcut: showShortcut,
                            displayFloat: displayFloat,
                            $T: this.$T,
                            toggleFloat: this.toggleFloat,
                        }),
                        React.createElement(DefaultStatusbar, __assign({}, this.props, { statusbarConfig: statusbarConfig }))),
                    React.createElement(Tabs, { withContent: true, onlyContent: tabInStatusbar, closeable: hasRouter, closeTip: this.$T('快捷键') + ": alt + w", className: "top-tab-wrapper tabs-container", activeTabIdx: hasRouter ? activeRouteIdx : 0, onClose: function (idx) { return _this.closeTab(idx, routerInfo); } }, hasRouter ? routers.map(function (route, idx) {
                        var C = pageComponents[route];
                        var currInfo = routerInfo[route];
                        var params = currInfo.params;
                        var key = route + JSON.stringify(params);
                        var isActive = activeRouteIdx === idx;
                        return (React.createElement(Tab, { contentClass: route, label: _this.$T(menuCodeMapper[route] || route), key: key, onChange: function (e) { return _this.changeRoute(route, params); } }, C ? (React.createElement(C, __assign({}, _this.getRouteProps(isActive, route)))) : NotfoundPage ? _this.loadPlugin(NotfoundPage) : (React.createElement(Notfound, { key: route + "404" }))));
                    }) : (React.createElement(Tab, { contentClass: "dash-board", label: this.$T('仪表盘'), key: "dash-board" },
                        React.createElement(DashBoardWrapper, __assign({ CustomerComponent: DashBoard, loadPlugin: this.loadPlugin }, this.getRouteProps(true)))))))))),
            React.createElement("div", { className: "fill fixbg main-bg-color", style: __assign(__assign({}, bgStyle), { zIndex: -1 }) }),
            React.createElement(VersionChecker, { versionUrl: versionUrl, versionInfo: versionInfo })));
    };
    ScaffoldLayout.setI18nUrl = function (nextUrl) {
        // i18nMapperUrl = nextUrl;
        console.warn('该接口已废弃，请通过传入 i18nMapperUrl 的 prop 指定');
    };
    ScaffoldLayout.defaultProps = {
        bgStyle: {},
        maxRouters: 10,
        defaultTheme: 'blue',
        defaultLayout: 'horizontal',
        versionUrl: './js/version.json',
        i18nMapperUrl: './i18n/',
        menuMappers: {
            child: 'child',
            code: 'code',
            title: 'title',
            icon: 'icon',
            pureIcon: 'pureIcon',
        },
        defaultDarkMode: false,
        statusbarConfig: [],
        tabInStatusbar: true,
        cacheState: true,
    };
    return ScaffoldLayout;
}(RouterHelper));
export default ScaffoldLayout;
