import { Component } from 'react';
import { SearchBoxProps } from './search';
export interface NavMenuProps {
    menuData: any;
    $T: (srcStr: string) => string;
    onDidMount?: (menuCodeMapper: any) => void;
    /** 菜单的字段映射 */
    menuMappers?: {
        child: string;
        code: string;
        title: string;
        icon?: string;
        pureIcon?: string;
    };
    flowMode?: boolean;
    show?: boolean;
    /** 标题 */
    title?: string;
    onToggleNav?: SearchBoxProps['onToggleNav'];
    onClickMenu?: () => void;
}
/**
 * 左菜单控件
 * 支持无限嵌套结构，支持“树”模式，支持“悬浮”模式
 * menuData 结构
 * {
 *   title: '',
 *   code: '',
 *   icon: '',
 *   child: [
 *     // 递归此结构, 避免和 react 的 children 冲突，故为 child
 *     {
 *       title: '',
 *       code: '',
 *       icon: '',
 *       child: []
 *     }
 *   ]
 * }
 */
export default class NavMenu extends Component<NavMenuProps, {
    showMenuMapper: {};
    flowMenuConfig: {
        activeItem: {};
        activeIdx: any;
        isShow: boolean;
        offset: {
            top: number;
            left: number;
        };
    };
    flowMode: boolean;
}> {
    flowModeKey: string;
    flowMenuContainer: any;
    constructor(props: any);
    componentDidMount(): void;
    getNormalMenuChildren: (initDataList: any) => never[] | undefined;
    hideFlowMenu: () => void;
    getMenuLinkerDOM: (options: any) => JSX.Element;
    getFlowModeDOM: (initDataList: any) => JSX.Element;
    menuItemFilter: (item: any) => any;
    showSearch: () => void;
    wrapLink: ({ path, code }: {
        path: any;
        code: any;
    }) => any;
    changeMenuUIMode: (isFlowMode: any) => void;
    toggleFold: (e: any, idx: any, isShow?: any) => void;
    setFlowMenu: (options: any) => void;
    render(): JSX.Element;
}
