import React from 'react';
import { ToolTip } from '../ui-refs';
var TabForNav = function (props) {
    var routers = props.routers, routersLen = props.routersLen, activeRouteIdx = props.activeRouteIdx, closeAll = props.closeAll, hasRouter = props.hasRouter, routerInfo = props.routerInfo, menuCodeMapper = props.menuCodeMapper, $T = props.$T, closeTab = props.closeTab, changeRoute = props.changeRoute, defaultTitle = props.defaultTitle;
    return (React.createElement("div", { className: "tabs-in-statusbar" },
        React.createElement("div", { className: "tabs-items" }, hasRouter ? (React.createElement(React.Fragment, null,
            React.createElement("span", { className: "tab-item close-all-btn" },
                React.createElement("span", { onClick: function (e) { return closeAll(); } },
                    React.createElement(ToolTip, { n: "window-close", title: "\u5173\u95ED\u6240\u6709\u6807\u7B7E" }))),
            routers.map(function (route, idx) {
                var isActive = activeRouteIdx === idx;
                var currInfo = routerInfo[route];
                var params = currInfo.params;
                var text = $T(menuCodeMapper[route] || route);
                return (React.createElement("span", { key: route, className: "tab-item" + (isActive ? ' active' : '') },
                    React.createElement("span", { onClick: function (e) { return changeRoute(route, params); }, className: "_btn text" }, text),
                    React.createElement("span", { className: "_btn close", onClick: function (e) { return closeTab(idx, routerInfo); } }, "x")));
            }))) : (React.createElement("span", { className: "tab-item active" }, defaultTitle())))));
};
export default TabForNav;
