import React, { useState } from 'react';
import Storage from 'basic-helper/storage';
import { NatureColors } from 'ukelli-ui/core/utils';
import { Switch } from '../ui-refs';
var _themes = NatureColors;
var _layout = ['vertical', 'horizontal'];
var themeDefined = '_THEME_';
var layoutDefined = '_LAYOUT_';
var darkModeDefined = '_DARK_MODE_';
var getThemeConfig = function () {
    var theme = Storage.getItem(themeDefined);
    var layout = Storage.getItem(layoutDefined);
    var darkMode = Storage.getItem(darkModeDefined);
    return {
        theme: theme, layout: layout, darkMode: darkMode == 'true'
    };
};
var setTheme = function (theme) {
    Storage.setItem(themeDefined, theme);
};
var setLayout = function (layout) {
    Storage.setItem(layoutDefined, layout);
};
var setDarkMode = function (darkMode) {
    Storage.setItem(darkModeDefined, darkMode);
};
var Theme = function (_a) {
    var activeTheme = _a.activeTheme, darkMode = _a.darkMode, layout = _a.layout, onChangeDarkMode = _a.onChangeDarkMode, onChangeTheme = _a.onChangeTheme, onChangeLayout = _a.onChangeLayout;
    var _b = useState(activeTheme), _activeTheme = _b[0], _setTheme = _b[1];
    return (React.createElement("div", { className: "theme-changer" },
        React.createElement("div", null,
            React.createElement("h5", null, "\u4E3B\u9898\u9009\u62E9"),
            _themes.map(function (color) {
                var isActive = _activeTheme === color;
                return (React.createElement("span", { className: "item " + (isActive ? 'active' : '') + " bg_" + color + " p10", key: color, onClick: function (e) {
                        _setTheme(color);
                        onChangeTheme(color);
                    } }));
            })),
        React.createElement("hr", null),
        React.createElement("h5", null, "\u9ED1\u591C\u6A21\u5F0F"),
        React.createElement(Switch, { defaultChecked: darkMode, onChange: onChangeDarkMode })));
};
export default Theme;
export { getThemeConfig, setTheme, setLayout, setDarkMode };
