var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React, { Component } from 'react';
import { createBrowserHistory } from "history";
import { getUrlParams, urlParamsToQuery } from 'uke-request/url-resolve';
import { RemoveArrayItem, CallFunc, IsUrl } from 'basic-helper';
var history = createBrowserHistory();
var ROUTE_KEY = '_R';
var changeRouteKey = function (routeKey) {
    ROUTE_KEY = routeKey;
};
var defaultState = {
    routers: [],
    routerInfo: {},
    activeRouteIdx: -1,
    activeRoute: '',
};
var cachedState = Object.assign({}, defaultState);
var pushToHistory = function (url, params) {
    history.push(url.replace(/\/\//g, '/'), params);
};
var replaceHistory = function (url, params) {
    history.replace(url.replace(/\/\//g, '/'), params);
};
var wrapPushUrl = function (pushConfig) {
    var _a;
    var _b = window.location, href = _b.href, hash = _b.hash;
    var targetHash = hash.replace('#/', '').split('?')[0];
    var component = pushConfig.component, route = pushConfig.route, params = pushConfig.params;
    var paramsObj = typeof params == 'string' ? { id: params } : __assign({}, params);
    var result = urlParamsToQuery({
        params: __assign((_a = {}, _a[ROUTE_KEY] = route || component, _a), paramsObj),
        toBase64: false
    });
    result = "" + targetHash + result.replace(/&&$/g, '');
    return result;
};
/**
 *
 * @param {object} config { type: 'PUSH | GO_BACK | LINK', component: route, params: {} }
 */
var onNavigate = function (config) {
    if (!config)
        return console.log('Not config');
    var location = history.location;
    config.from = location;
    switch (config.type) {
        case "PUSH":
            var pushUrl = wrapPushUrl(config);
            pushToHistory("#/" + pushUrl, config);
            break;
        case "LINK":
            break;
        // case "MODAL":
        //   ShowModal({
        //     ...config,
        //     showFuncBtn: false
        //   })
        //   break;
        case "GO_BACK":
            history.goBack();
            break;
    }
};
var resolvePath = function (path) {
    var result = path.split('?')[0].replace(/#/g, '');
    var pathArr = result.split('/').filter(function (item) { return !!item; });
    return pathArr;
};
var RouterHelper = /** @class */ (function (_super) {
    __extends(RouterHelper, _super);
    function RouterHelper(props) {
        var _this = _super.call(this, props) || this;
        _this.history = history;
        _this.wrapPushUrl = wrapPushUrl;
        _this.pushToHistory = pushToHistory;
        _this.onNavigate = onNavigate;
        _this.changeRoute = function (route, params) {
            onNavigate({
                type: 'PUSH',
                route: route,
                component: route,
                params: params
            });
        };
        _this.handleHistory = function (location, action) {
            var hash = location.hash, _a = location.state, state = _a === void 0 ? {} : _a;
            var activeRoute = getUrlParams()[ROUTE_KEY];
            var nextRouterState = state.nextRouters;
            _this.selectTab(activeRoute, nextRouterState);
        };
        _this.closeAll = function () {
            replaceHistory('/');
            _this.setState(function (prevState) {
                return __assign(__assign({}, prevState), defaultState);
            });
        };
        _this.closeTab = function (targetIdx) {
            var _a = _this.state, routers = _a.routers, routerInfo = _a.routerInfo, activeRouteIdx = _a.activeRouteIdx;
            var targetRoute = routers[targetIdx];
            var nextRouters = RemoveArrayItem(routers, targetRoute);
            var nextRouterInfo = __assign({}, routerInfo);
            delete nextRouterInfo[targetRoute];
            var nextRoutersLen = nextRouters.length - 1;
            var nextActiveIdx = activeRouteIdx > nextRoutersLen ? nextRoutersLen : activeRouteIdx;
            var nextActiveRoute = nextRouters[nextActiveIdx];
            if (!nextActiveRoute)
                return _this.closeAll();
            var nextRouterParams = nextRouterInfo[nextActiveRoute] || {};
            var nextState = {
                routers: nextRouters,
                routerInfo: nextRouterInfo,
                activeRoute: nextActiveRoute,
                activeRouteIdx: nextActiveIdx,
            };
            // pushToHistory(`#/${nextActiveRoute}`, {
            //   type: 'CLOSE',
            //   component: nextActiveRoute,
            //   params: nextRouterInfo,
            //   nextRouters: nextState
            // });
            var config = {
                type: 'PUSH',
                component: nextActiveRoute,
                params: nextRouterParams.params,
                nextRouters: nextState
            };
            // pushToHistory(wrapPushUrl(config), config);
            onNavigate(config);
            return nextState;
        };
        _this.selectTab = function (activeRoute, nextRouterState) {
            if (nextRouterState)
                return _this.setState(nextRouterState);
            if (!activeRoute)
                return;
            _this.setState(function (_a) {
                var routers = _a.routers, routerInfo = _a.routerInfo;
                var maxRouters = _this.props.maxRouters;
                var currComIdx = routers.indexOf(activeRoute);
                var nextRouters = __spreadArrays(routers);
                var nextRouterInfo = __assign({}, routerInfo);
                nextRouterInfo[activeRoute] = __assign(__assign({}, (nextRouterInfo[activeRoute] || {})), { params: getUrlParams() });
                var activeIdx = currComIdx;
                if (currComIdx == -1) {
                    nextRouters = __spreadArrays(routers, [activeRoute]);
                    /** 做最大路由控制 */
                    if (nextRouters.length > maxRouters) {
                        var target = nextRouters[0], other = nextRouters.slice(1);
                        nextRouters = other;
                        delete nextRouterInfo[target];
                    }
                    activeIdx = nextRouters.length - 1;
                }
                var nextState = {
                    activeRoute: activeRoute,
                    activeRouteIdx: activeIdx,
                    routers: nextRouters,
                    routerInfo: nextRouterInfo
                };
                cachedState = nextState;
                return nextState;
            });
        };
        _this.initRoute = function () {
            var initRoute = getUrlParams()[ROUTE_KEY];
            initRoute && _this.selectTab(initRoute);
        };
        var cacheState = props.cacheState;
        if (_this.unlisten)
            _this.unlisten();
        _this.unlisten = history.listen(_this.handleHistory);
        _this.state = cacheState ? cachedState : defaultState;
        return _this;
    }
    RouterHelper.prototype.componentDidMount = function () {
        this.initRoute();
    };
    return RouterHelper;
}(Component));
/**
 * 用于导航到另外页面的组件
 * @param {object} options 参数
 */
var Link = function (props) {
    var to = props.to, _a = props.className, className = _a === void 0 ? 'link-btn' : _a, children = props.children, onClick = props.onClick, params = props.params, isActive = props.isActive;
    var activeRoute = getUrlParams()[ROUTE_KEY];
    var _isActive = typeof isActive == 'undefined' ? activeRoute === to : isActive;
    return (React.createElement("span", { className: className + (_isActive ? ' active' : ''), onClick: function (e) {
            CallFunc(onClick)(e);
            if (IsUrl(to)) {
                window.open(to);
            }
            else {
                onNavigate({
                    type: 'PUSH',
                    route: to,
                    params: params
                });
            }
        } }, children));
};
Link.defaultProps = {
    className: 'link-btn',
    params: {}
};
export { RouterHelper, Link, history, wrapPushUrl, pushToHistory, changeRouteKey, onNavigate, };
