/**
 * 组件名    通用报表布局
 * 作者      Alex
 * 日期      2018-07-30
 */
import { Component } from 'react';
import { ReportTemplateProps, GetQueryDataResult, ReportTemplateState } from './types';
export default class ReportTemplate<P extends ReportTemplateProps = ReportTemplateProps> extends Component<P | ReportTemplateProps, ReportTemplateState> {
    static defaultProps: {
        autoQuery: boolean;
        defaultExpandCon: boolean;
        didMountQuery: boolean;
        needAutoRefresh: boolean;
        needClearBtn: boolean;
        hideFloatable: boolean;
        needCount: boolean;
        calculateHeight: boolean;
        querying: boolean;
        isMobile: boolean;
        needCheck: boolean;
        loadingCondition: boolean;
        showCondition: boolean;
        needPaging: boolean;
        template: string;
        conditionOptions: never[];
        $T: (str: any) => any;
        resDesc: string;
    };
    defaultPagin: {};
    audioMask: boolean;
    refreshTime: number;
    templateDOM: any;
    refreshTimer: any;
    soundUrl: any;
    soundType: any;
    soundRef: any;
    toast: any;
    conditionHelper: any;
    didMountQueried: any;
    tableContainerRef: any;
    __unmount: any;
    __setHeight: any;
    _tableRef: any;
    checkedItems: any;
    constructor(props: any);
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    setSoundUrl: (nextUrl: any) => void;
    setAutoRefreshTimer: () => void;
    clearAutoRefreshTimer: () => void;
    changeRefreshTime: (nextTime: any) => void;
    clearCheckeds: () => void;
    handleRes: ({ resDesc, hasErr }: {
        resDesc: any;
        hasErr: any;
    }) => void;
    whenMountedQuery: (data: any) => void;
    refreshData: () => void;
    /**
     * 获取查询条件
     * @param {object} conditionData 查询条件
     * @param {object} nextPagin 下一个分页数据
     * @param {boolean} [merge=true] 是否把 conditionData 合并到 this.conditionHelper.value 之中
     * @memberof ReportTemplate
     */
    getQueryData: (conditionData?: any, nextPagin?: any, merge?: boolean) => GetQueryDataResult;
    setTableContainerHeight: () => void;
    restoreBasicFloatLen: () => void;
    /**
     * 小数点开关
     * 在管理中心的时候可以用，但是关闭管理中心后必须设置回去
     */
    toggleFloat: () => void;
    handleQueryData: (val?: any, callback?: any) => void;
    handleChangeCondition: (val: any, ref: any) => void;
    saveConditionRef: (e: any) => void;
    handlePagin: (nextPagin: any) => void;
    toggleCondition: (isExpand: any) => void;
    saveWarnRef: (e: any) => void;
    saveToast: (toast: any) => void;
    renderAutoRefresh: () => JSX.Element;
    renderActionBtns: (actionBtns: any) => any;
    renderToggleBtn: () => JSX.Element;
    render(): JSX.Element;
}
