/**
 * 表格渲染模版
 */
import React from 'react';
import { NotifyConfig } from 'ukelli-ui/core/notification/notification';
import ReportTemplate from './records-template';
import { RecordActionBtn, ReportActionBtn } from './types';
export interface HOCReportRenderClass {
    /** 数据表的每一项（each row）的操作按钮 */
    recordActionBtns?: RecordActionBtn;
    /** 表格中的操作按钮 */
    reportActionBtns?: ReportActionBtn;
}
/**
 * HOCReportRender 接受 3 个参数
 *
 * @param {class} Action 具体业务 action
 * @param {object} [passProps={}] 传给模版引擎的 props
 * @param {class} [TemplatEngin=ReportTemplate] 自定义的模版引擎
 * @return {class} 返回用于 react 的类
 */
declare function HOCReportRender<P = HOCReportRenderClass>(Action: React.ComponentClass<P>, passProps?: {}, TemplatEngin?: typeof ReportTemplate): {
    new (props: P, context?: any): {
        /** 对于表格主体的 ref */
        ReportRef: any;
        /** 数据表的每一项（each row）的操作按钮 */
        recordActionBtns: any;
        /** 表格中的操作按钮 */
        reportActionBtns: any;
        getRecordBtns: (contentResult: any, record: any, mapper: any, rowIdx: any, ...other: any[]) => any[] | "-";
        /** 用于记录所有的按钮 */
        powerFilterForBtn: (btnId: any) => boolean;
        reportBtnFilter: () => any[] | null;
        getActionBtn: (...args: any[]) => void;
        showDesc: (showOptions: NotifyConfig) => void;
        saveReport: (e: any) => void;
        render(): JSX.Element;
        context: any;
        setState<K extends string | number | symbol>(state: any, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<P> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<any>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<P>, nextState: Readonly<any>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<P>, prevState: Readonly<any>): any;
        componentDidUpdate?(prevProps: Readonly<P>, prevState: Readonly<any>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<P>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<any>, nextContext: any): void;
    };
    propTypes?: React.WeakValidationMap<P> | undefined;
    contextType?: React.Context<any> | undefined;
    contextTypes?: import("prop-types").ValidationMap<any> | undefined;
    childContextTypes?: import("prop-types").ValidationMap<any> | undefined;
    defaultProps?: Partial<P> | undefined;
    displayName?: string | undefined;
    getDerivedStateFromProps?: React.GetDerivedStateFromProps<P, any> | undefined;
    getDerivedStateFromError?: React.GetDerivedStateFromError<P, any> | undefined;
} | null;
declare function GeneralReportRender(...args: any[]): void;
export { GeneralReportRender, HOCReportRender };
