/* eslint-disable no-continue */
/**
 * 表格渲染模版
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import React from 'react';
import { UUID, IsFunc } from 'basic-helper';
import { Notify } from '../../ui-refs';
import ReportTemplate from './records-template';
/**
 * 用于记录所有页面的按钮
 */
// let __btns = {};
// window.GetRegisteBtn = () => __btns;
var renameTip = function (before, after) {
    console.warn("\u8BF7\u628A " + before + " \u6539\u540D\u4E3A " + after);
};
/**
 * HOCReportRender 接受 3 个参数
 *
 * @param {class} Action 具体业务 action
 * @param {object} [passProps={}] 传给模版引擎的 props
 * @param {class} [TemplatEngin=ReportTemplate] 自定义的模版引擎
 * @return {class} 返回用于 react 的类
 */
function HOCReportRender(Action, passProps, TemplatEngin) {
    if (passProps === void 0) { passProps = {}; }
    if (TemplatEngin === void 0) { TemplatEngin = ReportTemplate; }
    if (!Action)
        return null;
    return /** @class */ (function (_super) {
        __extends(C, _super);
        function C() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.getRecordBtns = function (contentResult, record, mapper, rowIdx) {
                var other = [];
                for (var _i = 4; _i < arguments.length; _i++) {
                    other[_i - 4] = arguments[_i];
                }
                var _a = _this, actionBtnConfig = _a.actionBtnConfig, recordActionBtns = _a.recordActionBtns;
                if (actionBtnConfig)
                    renameTip('actionBtnConfig', 'recordActionBtns');
                var _recordActionBtns = recordActionBtns || actionBtnConfig;
                if (!_recordActionBtns)
                    return '-';
                var res = [];
                _recordActionBtns.forEach(function (config, idx) {
                    var text = config.text, action = config.action, id = config.id, _a = config.color, color = _a === void 0 ? 'blue' : _a, enable = config.enable;
                    /** 用于控制权限 */
                    var isActive = _this.powerFilterForBtn(id);
                    var isEnabled = IsFunc(enable) ? enable.apply(void 0, __spreadArrays([contentResult, record, mapper, rowIdx], other)) : true;
                    if (isActive && isEnabled) {
                        // if(!__btns[Action.name][id]) __btns[Action.name][id] = config;
                        res.push(React.createElement("span", { className: "link-btn mr5 t_" + color, key: text, onClick: function (e) {
                                action.apply(void 0, __spreadArrays([contentResult, record, mapper, rowIdx], other));
                            } }, _this.props.$T(text)));
                    }
                });
                return res;
            };
            /** 用于记录所有的按钮 */
            _this.powerFilterForBtn = function (btnId) {
                var _a = _this.props, powerMapper = _a.powerMapper, pageName = _a.pageName;
                if (!powerMapper || !pageName)
                    return true;
                return powerMapper.indexOf(pageName + "_" + btnId) > -1;
            };
            _this.reportBtnFilter = function () {
                var reportActionBtns = _this.reportActionBtns;
                if (!Array.isArray(reportActionBtns) || reportActionBtns.length === 0)
                    return null;
                var res = [];
                for (var _i = 0, reportActionBtns_1 = reportActionBtns; _i < reportActionBtns_1.length; _i++) {
                    var btn = reportActionBtns_1[_i];
                    var id = btn.id;
                    if (!id) {
                        console.warn('每个按钮需要设置 id，用于记录该按钮在对应页面的功能');
                        continue;
                    }
                    // __btns[Action.name][id] = true;
                    if (_this.powerFilterForBtn(btn.id))
                        res.push(btn);
                }
                return res;
            };
            _this.getActionBtn = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                renameTip('getActionBtn', 'getRecordBtns');
                _this.getRecordBtns.apply(_this, args);
            };
            _this.showDesc = function (showOptions) {
                var _a = showOptions.title, title = _a === void 0 ? '消息提示' : _a, text = showOptions.text, _b = showOptions.type, type = _b === void 0 ? 'error' : _b;
                if (!text)
                    return;
                Notify({
                    config: {
                        title: title,
                        type: type,
                        text: text,
                        id: UUID()
                    }
                });
            };
            _this.saveReport = function (e) { _this.ReportRef = e; };
            return _this;
        }
        C.prototype.render = function () {
            var scopeProps = Object.assign({}, {
                columns: this.columns,
                keyMapper: this.keyMapper,
                conditionOptions: this.conditionOptions,
                needCount: this.needCount,
                onChangeCondition: this.onChangeCondition,
                actionBtns: this.reportBtnFilter(),
                onQueryData: this.queryData.bind(this)
            });
            var props = Object.assign({}, passProps, this.templateOptions, this.state, this.props);
            return (React.createElement(TemplatEngin, __assign({}, scopeProps, props, { ref: this.saveReport })));
        };
        return C;
    }(Action));
}
function GeneralReportRender() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    renameTip('GeneralReportRender', 'HOCReportRender');
    HOCReportRender.apply(void 0, args);
}
export { GeneralReportRender, HOCReportRender };
